Module java.base
Package java.nio

## Class MappedByteBuffer

- java.lang.Object
- - java.nio.Buffer
  - - java.nio.ByteBuffer
    - - java.nio.MappedByteBuffer

All Implemented Interfaces:
  Comparable<ByteBuffer>

    public abstract class MappedByteBuffer
    extends ByteBuffer

A direct byte buffer whose content is a memory-mapped region of a file.

Mapped byte buffers are created via the `FileChannel.map` method. This class extends the `ByteBuffer` class with operations that are specific to memory-mapped file regions.

A mapped byte buffer and the file mapping that it represents remain valid until the buffer itself is garbage-collected.

The content of a mapped byte buffer can change at any time, for example if the content of the corresponding region of the mapped file is changed by this program or another. Whether or not such changes occur, and when they occur, is operating-system dependent and therefore unspecified.

All or part of a mapped byte buffer may become inaccessible at any time, for example if the mapped file is truncated. An attempt to access an inaccessible region of a mapped byte buffer will not change the buffer's content and will cause an unspecified exception to be thrown either at the time of the access or at some later time. It is therefore strongly recommended that appropriate precautions be taken to avoid the manipulation of a mapped file by this program, or by a concurrently running program, except to read or write the file's content.

Mapped byte buffers otherwise behave no differently than ordinary direct byte buffers.

Since:
  1.4

### Method Summary

All Methods Instance Methods Concrete Methods
`MappedByteBuffer` `clear()` Clears this buffer.
`MappedByteBuffer` `flip()` Flips this buffer.
`MappedByteBuffer` `force()` Forces any changes made to this buffer's content to be written to the storage device containing the mapped file.
`boolean` `isLoaded()` Tells whether or not this buffer's content is resident in physical memory.
`MappedByteBuffer` `limit(int newLimit)` Sets this buffer's limit.
`MappedByteBuffer` `load()` Loads this buffer's content into physical memory.
`MappedByteBuffer` `mark()` Sets this buffer's mark at its position.
`MappedByteBuffer` `position(int newPosition)` Sets this buffer's position.
`MappedByteBuffer` `reset()` Resets this buffer's position to the previously-marked position.
`MappedByteBuffer` `rewind()` Rewinds this buffer.

### Methods inherited from class java.nio.Buffer

`capacity, hasRemaining, isReadOnly, limit, position, remaining`

### Methods inherited from class java.nio.ByteBuffer

`alignedSlice, alignmentOffset, allocate, allocateDirect, array, arrayOffset, asCharBuffer, asDoubleBuffer, asFloatBuffer, asIntBuffer, asLongBuffer, asReadOnlyBuffer, asShortBuffer, compact, compareTo, duplicate, equals, get, get, get, get, getChar, getChar, getDouble, getDouble, getFloat, getFloat, getInt, getInt, getLong, getLong, getShort, getShort, hasArray, hashCode, isDirect, order, order, put, put, put, put, put, putChar, putChar, putDouble, putDouble, putFloat, putFloat, putInt, putInt, putLong, putLong, putShort, putShort, slice, toString, wrap, wrap`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Method Detail

#### isLoaded

    public final boolean isLoaded()

Tells whether or not this buffer's content is resident in physical memory.

A return value of `true` implies that it is highly likely that all of the data in this buffer is resident in physical memory and may therefore be accessed without incurring any virtual-memory page faults or I/O operations. A return value of `false` does not necessarily imply that the buffer's content is not resident in physical memory.

The returned value is a hint, rather than a guarantee, because the underlying operating system may have paged out some of the buffer's data by the time that an invocation of this method returns.

Returns:
  `true` if it is likely that this buffer's content is resident in physical memory

#### load

    public final MappedByteBuffer load()

Loads this buffer's content into physical memory.

This method makes a best effort to ensure that, when it returns, this buffer's content is resident in physical memory. Invoking this method may cause some number of page faults and I/O operations to occur.

Returns:
  This buffer

#### force

    public final MappedByteBuffer force()

Forces any changes made to this buffer's content to be written to the storage device containing the mapped file.

If the file mapped into this buffer resides on a local storage device then when this method returns it is guaranteed that all changes made to the buffer since it was created, or since this method was last invoked, will have been written to that device.

If the file does not reside on a local device then no such guarantee is made.

If this buffer was not mapped in read/write mode (`FileChannel.MapMode.READ_WRITE`) then invoking this method has no effect.

Returns:
  This buffer

#### position

    public final MappedByteBuffer position(int newPosition)

Sets this buffer's position. If the mark is defined and larger than the new position then it is discarded.

Overrides:
  `position` in class `ByteBuffer`
Parameters:
  `newPosition` - The new position value; must be non-negative and no larger than the current limit
Returns:
  This buffer
Since:
  9

#### limit

    public final MappedByteBuffer limit(int newLimit)

Sets this buffer's limit. If the position is larger than the new limit then it is set to the new limit. If the mark is defined and larger than the new limit then it is discarded.

Overrides:
  `limit` in class `ByteBuffer`
Parameters:
  `newLimit` - The new limit value; must be non-negative and no larger than this buffer's capacity
Returns:
  This buffer
Since:
  9

#### mark

    public final MappedByteBuffer mark()

Sets this buffer's mark at its position.

Overrides:
  `mark` in class `ByteBuffer`
Returns:
  This buffer
Since:
  9

#### reset

    public final MappedByteBuffer reset()

Resets this buffer's position to the previously-marked position.

Invoking this method neither changes nor discards the mark's value.

Overrides:
  `reset` in class `ByteBuffer`
Returns:
  This buffer
Since:
  9

#### clear

    public final MappedByteBuffer clear()

Clears this buffer. The position is set to zero, the limit is set to the capacity, and the mark is discarded.

Invoke this method before using a sequence of channel-read or put operations to fill this buffer. For example:

>      buf.clear();     // Prepare buffer for reading
>      in.read(buf);    // Read data

This method does not actually erase the data in the buffer, but it is named as if it did because it will most often be used in situations in which that might as well be the case.

Overrides:
  `clear` in class `ByteBuffer`
Returns:
  This buffer
Since:
  9

#### flip

    public final MappedByteBuffer flip()

Flips this buffer. The limit is set to the current position and then the position is set to zero. If the mark is defined then it is discarded.

After a sequence of channel-read or put operations, invoke this method to prepare for a sequence of channel-write or relative get operations. For example:

>      buf.put(magic);    // Prepend header
>      in.read(buf);      // Read data into rest of buffer
>      buf.flip();        // Flip buffer
>      out.write(buf);    // Write header + data to channel

This method is often used in conjunction with the `compact` method when transferring data from one place to another.

Overrides:
  `flip` in class `ByteBuffer`
Returns:
  This buffer
Since:
  9

#### rewind

    public final MappedByteBuffer rewind()

Rewinds this buffer. The position is set to zero and the mark is discarded.

Invoke this method before a sequence of channel-write or get operations, assuming that the limit has already been set appropriately. For example:

>      out.write(buf);    // Write remaining data
>      buf.rewind();      // Rewind buffer
>      buf.get(array);    // Copy data into array

Overrides:
  `rewind` in class `ByteBuffer`
Returns:
  This buffer
Since:
  9